Module ParticleMod
  type particle
    real(kind(1.0D0)) :: position(3)
    real(kind(1.0D0)) :: velocity(3)
    real(kind(1.0D0)) :: mass
    integer(kind=1) :: char_element
  end type particle
End Module ParticleMod

module m_ArrayTypes
  use F90_kinds
  type F90_Array1DI_t
    integer, pointer :: data(:)
 end type F90_Array1DI_t
  type F90_Array3DI_t
    integer, pointer :: data(:,:,:)
 end type F90_Array3DI_t
end module m_ArrayTypes


function test_neg_lb(a)
  implicit none
  integer :: test_neg_lb
  integer :: a(:,:), lb(2)

  lb = lbound(a)
  print *, lb
  test_neg_lb = 0
  
end function test_neg_lb


subroutine print_sizeofs()
  use F90_kinds
  external c_sizeof
  logical(kind=IKIND1) :: l1a(3)
  logical(kind=IKIND2) :: l2a(3)
  logical(kind=IKIND4) :: l4a(3)
  logical(kind=IKIND8) :: l8a(3)
  logical :: la(3)
  integer(kind=IKIND1) :: i1a(3)
  integer(kind=IKIND2) :: i2a(3)
  integer(kind=IKIND4) :: i4a(3)
  integer(kind=IKIND8) :: i8a(3)
  integer :: size, ia(3)
  real :: ra(3)
  real(kind(1.0D0)) :: da(3)

  call c_sizeof(size, l1a(2), l1a(1))
  print *, "  sizeof LKIND1 = ", size
  call c_sizeof(size, l2a(2), l2a(1))
  print *, "  sizeof LKIND2 = ", size
  call c_sizeof(size, l4a(2), l4a(1))
  print *, "  sizeof LKIND4 = ", size
  call c_sizeof(size, l8a(2), l8a(1))
  print *, "  sizeof LKIND8 = ", size
  call c_sizeof(size, la(2), la(1))
  print *, "  sizeof logical= ", size
  call c_sizeof(size, i1a(2), i1a(1))
  print *, "  sizeof IKIND1 = ", size
  call c_sizeof(size, i2a(2), i2a(1))
  print *, "  sizeof IKIND2 = ", size
  call c_sizeof(size, i4a(2), i4a(1))
  print *, "  sizeof IKIND4 = ", size
  call c_sizeof(size, i8a(2), i8a(1))
  print *, "  sizeof IKIND8 = ", size
  call c_sizeof(size, ia(2), ia(1))
  print *, "  sizeof    int = ", size
  call c_sizeof(size, ra(2), ra(1))
  print *, "  sizeof   real = ", size
  call c_sizeof(size, da(2), da(1))
  print *, "  sizeof double = ", size

end subroutine print_sizeofs


subroutine send_iia1d_null()
  interface
    subroutine recv_iia1d_null(a)
      integer, pointer :: a(:)
    end subroutine
  end interface
  integer, target, save :: a(10)
  integer, pointer, save :: pa(:)
  pa => a
  nullify(pa)
  call recv_iia1d_null(pa)
end subroutine send_iia1d_null

subroutine send_iia1d()
  interface
    subroutine recv_iia1d(a)
      integer, pointer :: a(:)
    end subroutine
  end interface
  integer, target, save :: a(10)
  integer, pointer, save :: pa(:)
  pa => a
  call recv_iia1d(pa)
end subroutine send_iia1d

subroutine send_iia2d()
  interface
    subroutine recv_iia2d(a)
      integer, pointer :: a(:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2)
  integer, pointer, save :: pa(:,:)
  pa => a
  call recv_iia2d(pa)
end subroutine send_iia2d

subroutine send_iia3d()
  interface
    subroutine recv_iia3d(a)
      integer, pointer :: a(:,:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2,3)
  integer, pointer, save :: pa(:,:,:)
  pa => a
  call recv_iia3d(pa)
end subroutine send_iia3d

subroutine send_iia4d()
  interface
    subroutine recv_iia4d(a)
      integer, pointer :: a(:,:,:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2,3,4)
  integer, pointer, save :: pa(:,:,:,:)
  pa => a
  call recv_iia4d(pa)
end subroutine send_iia4d

subroutine send_iia5d()
  interface
    subroutine recv_iia5d(a)
      integer, pointer :: a(:,:,:,:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2,3,4,5)
  integer, pointer, save :: pa(:,:,:,:,:)
  pa => a
  call recv_iia5d(pa)
end subroutine send_iia5d

subroutine send_iia6d()
  interface
    subroutine recv_iia6d(a)
      integer, pointer :: a(:,:,:,:,:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2,3,4,5,6)
  integer, pointer, save :: pa(:,:,:,:,:,:)
  pa => a
  call recv_iia6d(pa)
end subroutine send_iia6d

subroutine send_iia7d()
  interface
    subroutine recv_iia7d(a)
      integer, pointer :: a(:,:,:,:,:,:,:)
    end subroutine
  end interface
  integer, target, save :: a(1,2,3,4,5,6,7)
  integer, pointer, save :: pa(:,:,:,:,:,:,:)
  pa => a
  call recv_iia7d(pa)
end subroutine send_iia7d


subroutine send_lla0d()
  use F90_kinds
  interface
    subroutine recv_lla0d(l)
      use F90_kinds
      logical, pointer :: l
    end subroutine
  end interface
  logical, target, save :: l
  logical, pointer, save :: pl
  pl => l
  call recv_lla0d(pl)
end subroutine send_lla0d

subroutine send_l1a0d()
  use F90_kinds
  interface
    subroutine recv_l1a0d(p)
      use F90_kinds
      logical(kind=IKIND1), pointer :: p
    end subroutine
  end interface
  logical(kind=IKIND1), target, save :: l
  logical(kind=IKIND1), pointer, save :: pl
  pl => l
  call recv_l1a0d(pl)
end subroutine send_l1a0d

subroutine send_l2a0d()
  use F90_kinds
  interface
    subroutine recv_l2a0d(p)
      use F90_kinds
      logical(kind=IKIND2), pointer :: p
    end subroutine
  end interface
  logical(kind=IKIND2), target, save :: l
  logical(kind=IKIND2), pointer, save :: pl
  pl => l
  call recv_l2a0d(pl)
end subroutine send_l2a0d

subroutine send_l4a0d()
  use F90_kinds
  interface
    subroutine recv_l4a0d(p)
      use F90_kinds
      logical(kind=IKIND4), pointer :: p
    end subroutine
  end interface
  logical(kind=IKIND4), target, save :: l
  logical(kind=IKIND4), pointer, save :: pl
  pl => l
  call recv_l4a0d(pl)
end subroutine send_l4a0d

subroutine send_l8a0d()
  use F90_kinds
  interface
    subroutine recv_l8a0d(p)
      use F90_kinds
      logical(kind=IKIND8), pointer :: p
    end subroutine
  end interface
  logical(kind=IKIND8), target, save :: l
  logical(kind=IKIND8), pointer, save :: pl
  pl => l
  call recv_l8a0d(pl)
end subroutine send_l8a0d

subroutine send_lla1d()
  use F90_kinds
  interface
    subroutine recv_lla1d(a)
      use F90_kinds
      logical, pointer :: a(:)
    end subroutine
  end interface
  logical, target, save :: a(10)
  logical, pointer, save :: pa(:)
  pa => a
  call recv_lla1d(pa)
end subroutine send_lla1d

subroutine send_l1a1d()
  use F90_kinds
  interface
    subroutine recv_l1a1d(a)
      use F90_kinds
      logical(kind=IKIND1), pointer :: a(:)
    end subroutine
  end interface
  logical(kind=IKIND1), target, save :: a(10)
  logical(kind=IKIND1), pointer, save :: pa(:)
  pa => a
  call recv_l1a1d(pa)
end subroutine send_l1a1d

subroutine send_l2a1d()
  use F90_kinds
  interface
    subroutine recv_l2a1d(a)
      use F90_kinds
      logical(kind=IKIND2), pointer :: a(:)
    end subroutine
  end interface
  logical(kind=IKIND2), target, save :: a(10)
  logical(kind=IKIND2), pointer, save :: pa(:)
  pa => a
  call recv_l2a1d(pa)
end subroutine send_l2a1d

subroutine send_l4a1d()
  use F90_kinds
  interface
    subroutine recv_l4a1d(a)
      use F90_kinds
      logical(kind=IKIND4), pointer :: a(:)
    end subroutine
  end interface
  logical(kind=IKIND4), target, save :: a(10)
  logical(kind=IKIND4), pointer, save :: pa(:)
  pa => a
  call recv_l4a1d(pa)
end subroutine send_l4a1d

subroutine send_l8a1d()
  use F90_kinds
  interface
    subroutine recv_l8a1d(a)
      use F90_kinds
      logical(kind=IKIND8), pointer :: a(:)
    end subroutine
  end interface
  logical(kind=IKIND8), target, save :: a(10)
  logical(kind=IKIND8), pointer, save :: pa(:)
  pa => a
  call recv_l8a1d(pa)
end subroutine send_l8a1d

subroutine send_i1a1d()
  use F90_kinds
  interface
    subroutine recv_i1a1d(a)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:)
    end subroutine
  end interface
  integer(kind=IKIND1), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND1), pointer, save :: pa(:)
  pa => a
  call recv_i1a1d(pa)
end subroutine send_i1a1d

subroutine send_i2a1d()
  use F90_kinds
  interface
    subroutine recv_i2a1d(a)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:)
    end subroutine
  end interface
  integer(kind=IKIND2), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND2), pointer, save :: pa(:)
  pa => a
  call recv_i2a1d(pa)
end subroutine send_i2a1d

subroutine send_i4a1d()
  use F90_kinds
  interface
    subroutine recv_i4a1d(a)
      use F90_kinds
      integer(kind=IKIND4), pointer :: a(:)
    end subroutine
  end interface
  integer(kind=IKIND4), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND4), pointer, save :: pa(:)
  pa => a
  call recv_i4a1d(pa)
end subroutine send_i4a1d

subroutine send_i8a1d()
  use F90_kinds
  interface
    subroutine recv_i8a1d(a)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:)
    end subroutine
  end interface
  integer(kind=IKIND8), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND8), pointer, save :: pa(:)
  pa => a
  call recv_i8a1d(pa)
end subroutine send_i8a1d

subroutine send_rra1d()
  interface
    subroutine recv_rra1d(a)
      real, pointer :: a(:)
    end subroutine
  end interface
  real, target, save :: a(10)
  real, pointer, save :: pa(:)
  pa => a
  call recv_rra1d(pa)
end subroutine send_rra1d

subroutine send_dda1d()
  interface
    subroutine recv_dda1d(a)
      real(kind(1.0D0)), pointer :: a(:)
    end subroutine
  end interface
  real(kind(1.0D0)), target, save :: a(10)
  real(kind(1.0D0)), pointer, save :: pa(:)
  pa => a
  call recv_dda1d(pa)
end subroutine send_dda1d

subroutine send_ca0d()
  interface
    subroutine recv_ca0d(pc)
      complex, pointer :: pc
    end subroutine
  end interface
  complex, target, save :: c
  complex, pointer, save :: pc
  pc => c
  call recv_ca0d(pc)
end subroutine send_ca0d

subroutine send_ca1d()
  interface
    subroutine recv_ca1d(a)
      complex, pointer :: a(:)
    end subroutine
  end interface
  complex, target, save :: a(10)
  complex, pointer, save :: pa(:)
  pa => a
  call recv_ca1d(pa)
end subroutine send_ca1d

subroutine send_dca0d()
  interface
    subroutine recv_dca0d(pc)
      complex(kind(1.0D0)), pointer :: pc
    end subroutine
  end interface
  complex(kind(1.0D0)), target, save :: c
  complex(kind(1.0D0)), pointer, save :: pc
  pc => c
  call recv_dca0d(pc)
end subroutine send_dca0d

subroutine send_dca1d()
  interface
    subroutine recv_dca1d(a)
      complex(kind(1.0D0)), pointer :: a(:)
    end subroutine
  end interface
  complex(kind(1.0D0)), target, save :: a(10)
  complex(kind(1.0D0)), pointer, save :: pa(:)
  pa => a
  call recv_dca1d(pa)
end subroutine send_dca1d

subroutine send_ua0d()
  use ParticleMod
  interface
    subroutine recv_ua0d(pd)
      use ParticleMod
      type(Particle), pointer :: pd
    end subroutine
  end interface
  type(Particle), target, save :: d
  type(Particle), pointer, save :: pd
  pd => d
  call recv_ua0d(pd)
end subroutine send_ua0d

subroutine send_ua1d()
  use ParticleMod
  interface
    subroutine recv_ua1d(a)
      use ParticleMod
      type(Particle), pointer :: a(:)
    end subroutine
  end interface
  type(Particle), target, save :: a(3:99)
  type(Particle), pointer, save :: pa(:)
  pa => a
  call recv_ua1d(pa)
end subroutine send_ua1d

subroutine send_upa1d()
  use F90_kinds
  use m_ArrayTypes
  interface
    subroutine recv_upa1d(a_t)
      use m_ArrayTypes
      type(F90_Array1DI_t), intent(out) :: a_t
    end subroutine
  end interface
  integer, target, save :: a(-1:9)
  type(F90_Array1DI_t), save :: a_t

  a_t%data => a
  call recv_upa1d(a_t)
end subroutine send_upa1d

subroutine send_iia0d()
  interface
    subroutine recv_iia0d(ip)
      integer, pointer :: ip
    end subroutine
  end interface
  integer, target, save :: i
  integer, pointer, save :: ip

  i = 3
  ip => i
  call recv_iia0d(ip)
end subroutine send_iia0d

subroutine send_i1a0d()
  interface
    subroutine recv_i1a0d(ip)
      integer, pointer :: ip
    end subroutine
  end interface
  integer, target, save :: i
  integer, pointer, save :: ip

  ip => i
  call recv_i1a0d(ip)
end subroutine send_i1a0d

subroutine send_i2a0d()
  interface
    subroutine recv_i2a0d(ip)
      integer, pointer :: ip
    end subroutine
  end interface
  integer, target, save :: i
  integer, pointer, save :: ip

  ip => i
  call recv_i2a0d(ip)
end subroutine send_i2a0d

subroutine send_i4a0d()
  interface
    subroutine recv_i4a0d(ip)
      integer, pointer :: ip
    end subroutine
  end interface
  integer, target, save :: i
  integer, pointer, save :: ip

  ip => i
  call recv_i4a0d(ip)
end subroutine send_i4a0d

subroutine send_i8a0d()
  interface
    subroutine recv_i8a0d(ip)
      integer, pointer :: ip
    end subroutine
  end interface
  integer, target, save :: i
  integer, pointer, save :: ip

  ip => i
  call recv_i8a0d(ip)
end subroutine send_i8a0d


subroutine send_i1a1d_print(code, ii)
  use F90_kinds
  interface
    subroutine recv_i1a1d(a)
      use F90_kinds
      integer(kind=IKIND1), pointer :: a(:)
    end subroutine
  end interface
  external print_iaddr
  external print_i1a
  integer :: code, ii
  integer(kind=IKIND1), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND1), pointer, save :: pa(:)
  pa => a
  call recv_i1a1d(pa)

  ii = 6
  if (code .eq. 1) then
    call print_iaddr(a(1))
    call print_iaddr(a(2))
    call print_i1a(a, ii)
  end if
  call recv_i1a1d(pa)
end subroutine send_i1a1d_print


subroutine send_i2a1d_print(code, ii)
  use F90_kinds
  interface
    subroutine recv_i2a1d(a)
      use F90_kinds
      integer(kind=IKIND2), pointer :: a(:)
    end subroutine
  end interface
  external print_iaddr
  external print_i2a
  integer :: code, ii
  integer(kind=IKIND2), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND2), pointer, save :: pa(:)
  pa => a
  call recv_i2a1d(pa)

  ii = 6
  if (code .eq. 1) then
    call print_iaddr(a(1))
    call print_iaddr(a(2))
    call print_i2a(a, ii)
  end if
  call recv_i2a1d(pa)
end subroutine send_i2a1d_print


subroutine send_i4a1d_print(code, ii)
  use F90_kinds
  interface
    subroutine recv_i4a1d(a)
      use F90_kinds
      integer(kind=IKIND4), pointer :: a(:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, ii
  integer(kind=IKIND4), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND4), pointer, save :: pa(:)
  pa => a
  call recv_i4a1d(pa)

  ii = 6
  if (code .eq. 1) then
    call print_iaddr(a(1))
    call print_iaddr(a(2))
    call print_ia(a, ii)
  end if
  call recv_i4a1d(pa)
end subroutine send_i4a1d_print


subroutine send_i8a1d_print(code, ii)
  use F90_kinds
  interface
    subroutine recv_i8a1d(a)
      use F90_kinds
      integer(kind=IKIND8), pointer :: a(:)
    end subroutine
  end interface
  external print_iaddr
  external print_i8a
  integer :: code, ii
  integer(kind=IKIND8), target, save :: a(10) = (/1,2,3,4,5,6,7,8,9,10/)
  integer(kind=IKIND8), pointer, save :: pa(:)
  pa => a
  call recv_i8a1d(pa)

  ii = 6
  if (code .eq. 1) then
    call print_iaddr(a(1))
    call print_iaddr(a(2))
    call print_i8a(a, ii)
  end if
  call recv_i8a1d(pa)
end subroutine send_i8a1d_print


subroutine send_ia1d(code, ii)
  interface
    subroutine recv_ia1d(a)
      integer :: a(:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, i, ii
  integer, allocatable, save :: a(:)

  if (allocated(a)) deallocate(a)

  if (ii .lt. 0) ii = 6
  allocate(a(ii))    

  do i = 1, ii
    a(i) = i
  end do

  if (code .eq. 1) then
    call print_iaddr(a(1))
    call print_iaddr(a(2))
    call print_ia(a, ii)
  end if
  call recv_ia1d(a)
end subroutine send_ia1d


subroutine send_ia2d(code, ii, jj)
  interface
    subroutine recv_ia2d(a)
      integer :: a(:,:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, i, ii, j, jj
  integer, allocatable, save :: a(:,:)

  if (allocated(a)) deallocate(a)

  if (ii .lt. 0) ii = 3
  if (jj .lt. 0) jj = 4
  allocate(a(ii,jj))    

  do i = 1, ii
    do j = 1, jj
      a(i,j) = i*10 + j
    end do
  end do
  if (code .eq. 1) then
    call print_iaddr(a)
    call print_ia(a, 6)
  end if
  call recv_ia2d(a)
end subroutine send_ia2d


subroutine send_ia3d(code, ii, jj, kk)
  interface
    subroutine recv_ia3d(a)
      integer :: a(:,:,:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, ii, i, jj, j, kk, k
  integer, allocatable, save :: a(:,:,:)

  if (allocated(a)) deallocate(a)

  if (ii .lt. 0) ii = 3
  if (jj .lt. 0) jj = 4
  if (kk .lt. 0) kk = 4
  allocate(a(ii,jj,kk))    


  do i = 1, ii
    do j = 1, jj
      do k = 1, kk
        a(i,j,k) = i*100 + j*10 + k
      end do
    end do
  end do
  if (code .eq. 1) then
    call print_iaddr(a)
    call print_ia(a, 6)
  end if
  call recv_ia3d(a)

end subroutine send_ia3d


subroutine send_ia3d_s(code, count)
  interface
    subroutine recv_ia3d_s(a)
      integer :: a(:,:,:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, count, i, j, k
  integer, save :: a(3,4,5)

  do i = 1, 3
    do j = 1, 4
      do k = 1, 5
        a(i,j,k) = i*100 + j*10 + k
      end do
    end do
  end do
  count = 345
  if (code .eq. 1) then
    call print_iaddr(a)
    call print_ia(a, 6)
  end if
  call recv_ia3d_s(a(2:3,:,:))

end subroutine send_ia3d_s


subroutine send_ia3d_p(code, count)
  interface
    subroutine recv_ia3d_p(a)
      integer, pointer :: a(:,:,:)
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, count, i, j, k
  integer, target, save :: a(0:2,0:3,0:4)
  integer, pointer, save :: pa(:,:,:)

  do i = 1, 3
    do j = 1, 4
      do k = 1, 5
        a(i-1,j-1,k-1) = i*100 + j*10 + k
      end do
    end do
  end do
  count = 345

  pa => a
  if (code .eq. 1) then
    call print_iaddr(a)
    call print_ia(pa, 6)
  end if
  call recv_ia3d_p(pa)

end subroutine send_ia3d_p


subroutine send_ia3d_dp(code, count)
  use m_ArrayTypes
  interface
    subroutine recv_ia3d_dp(a_t)
      use m_ArrayTypes
      type(F90_Array3DI_t), intent(in) :: a_t
    end subroutine
  end interface
  external print_iaddr
  external print_ia
  integer :: code, count, i, j, k
  type(F90_Array3dI_t), save :: a_t
  integer, target, save :: a(0:2,0:3,-1:3)

  do i = 1, 3
    do j = 1, 4
      do k = 1, 5
        a(i-1,j-1,k-2) = i*100 + j*10 + k
      end do
    end do
  end do
  count = 345

  a_t%data => a
  if (code .eq. 1) then
    call print_iaddr(a_t%data)
    call print_ia(a_t%data, 6)
  end if
  call recv_ia3d_dp(a_t)

end subroutine send_ia3d_dp


subroutine send_ra0d()
  interface
    subroutine recv_ra0d(xp)
      real, pointer :: xp
    end subroutine
  end interface
  real, target, save :: x
  real, pointer, save :: xp

  x = 33.3
  xp => x
  call recv_ra0d(xp)

end subroutine send_ra0d


subroutine send_ra1d(code, count)
  interface
    subroutine recv_ra1d(a)
      real :: a(:)
    end subroutine
  end interface
  external print_raddr
  external print_ra
  integer :: code, count
  real, save :: a(3)
  data a/0.1, 0.2, 0.3/

  count = 3
  if (code .eq. 1) then
    call print_raddr(a(1))
    call print_raddr(a(2))
    call print_ra(a, 3)
  end if
  call recv_ra1d(a)

end subroutine send_ra1d


subroutine send_ra2d(code, count)
  interface
    subroutine recv_ra2d(a)
      real :: a(:,:)
    end subroutine
  end interface
  external print_raddr
  external print_ra
  integer :: code, count, i, j
  real, save :: a(3,4)

  do i = 1, 3
    do j = 1, 4
      a(i,j) = (i*10 + j)/10.
    end do
  end do
  count = 34

  if (code .eq. 1) then
    call print_raddr(a)
    call print_ra(a, 3)
  end if
  call recv_ra2d(a)

end subroutine send_ra2d


subroutine send_ra3d(code, count)
  interface
    subroutine recv_ra3d(a)
      real :: a(:,:,:)
    end subroutine
  end interface
  external print_raddr
  external print_ra
  integer :: code, count
  real, save :: a(3,4,5)

  do i = 1, 3
    do j = 1, 4
      do k = 1, 5
        a(i,j,k) = (i*100 + j*10 + k)/10.
      end do
    end do
  end do
  count = 345

  if (code .eq. 1) then
    call print_raddr(a)
    call print_ra(a, 3)
  end if
  call recv_ra3d(a)

end subroutine send_ra3d

subroutine send_da0d()
  interface
    subroutine recv_da0d(dp)
      real(kind(1.0D0)), pointer :: dp
    end subroutine
  end interface
  real(kind(1.0D0)), save, target :: d
  real(kind(1.0D0)), save, pointer :: dp

  dp => d
  call recv_da0d(dp)
end subroutine send_da0d

subroutine send_da1d(code, count)
  interface
    subroutine recv_da1d(a)
      real(kind(1.0D0)) :: a(:)
    end subroutine
  end interface
  external print_daddr
  external print_da
  integer :: code, count
  real(kind(1.0D0)), save :: a(3)
  data a/1.1D0, 1.2D0, 1.3D0/

  count = 3
  if (code .eq. 1) then
    call print_daddr(a(1))
    call print_daddr(a(2))
    call print_da(a, 3)
  end if
  call recv_da1d(a)

end subroutine send_da1d

