function test_neg_lb(a, ta)
  use F90_ArrayTypes
  implicit none
  integer :: test_neg_lb
  integer :: a(:,:), lb(2), ub(2)
  type(F90_Array2DI_t) :: ta

  lb = lbound(a)
  ub = ubound(a)

  print *
  print *, "shape(a) = ", shape(a)
  print *, "lower bound(a) = ", lb
  print *, "upper bound(a) = ", ub

  lb = lbound(ta%data)
  ub = ubound(ta%data)

  print *
  print *, "shape(ta%data) = ", shape(ta%data)
  print *, "lower bound(ta%data) = ", lb
  print *, "upper bound(ta%data) = ", ub

  test_neg_lb = 0
  
end function test_neg_lb


program main
  use F90_ArrayTypes
  interface
    function test_neg_lb(a, ta)
      use F90_ArrayTypes
      integer :: test_neg_lb
      integer :: a(:,:)
      type(F90_Array2DI_t) :: ta
    end function test_neg_lb
  end interface

  integer, target :: a(-99:-98, -1:1)
  type(F90_Array2DI_t) :: ta
  integer :: rc, lb(2), ub(2)

  lb = lbound(a)
  ub = ubound(a)

  print *, "shape = ", shape(a)
  print *, "lower bound = ", lb
  print *, "upper bound = ", ub

  ta%data => a

  rc = test_neg_lb(a, ta)

end program main
