program test_ga
  implicit none
  interface
    subroutine create_ga(a, ashape, error)
      integer, pointer :: a(:,:)
      integer, intent(in) :: ashape(2)
      integer, intent(out) :: error
    end subroutine create_ga
  end interface

  integer :: nx, ny, i, j
  integer, pointer :: a(:,:)
  integer :: ashape(2), albound(2), aubound(2)
  integer :: rc
  logical :: error, debug

  error = .false.
  debug = .false.

  nx = 9
  ny = 5
  ashape(1) = nx
  ashape(2) = ny
  call create_ga(a, ashape, rc)
  ashape(1) = 0
  ashape(2) = 0

  if (rc .ne. 0) then
      print *, "ERROR in create_ga"
      error = .true.
      stop 1
   end if

  if (.not. associated(a)) then
      error = .true.
      print *, "ERROR, a is unassociated"
      stop 1
   end if

  ashape  = shape(a)
  albound = lbound(a)
  aubound = ubound(a)
  
  if (ashape(1) .ne. nx)  error = .true.
  if (ashape(2) .ne. ny)  error = .true.
  if (aubound(1) .ne. nx) error = .true.
  if (aubound(2) .ne. ny) error = .true.

  if (error) then
     print *, "ERROR in shape and bounds "
     print *, "nx = ", nx, "ny = ", ny
     print *, "shape = ", ashape
     print *, "lbound = ", albound
     print *, "ubound = ", aubound
     stop 1
  end if

  if (debug) then
    do j = 1, ny
       print *, a(j, 1:nx)
    end do
  end if

  do i = 1, nx
    do j = 1, ny
      if ( a(j,i) .ne. i + 10*j) then
         error = .true.
         print *, "ERROR, a(", j, ",", i, ") = ", a(j,i)
         stop 1
      end if
    end do
  end do
 
end program test_ga
