program test_reset_F
  implicit none
  interface
    subroutine test_reset(rank, a, elem_size, ashape)
      integer :: rank, elem_size
      integer, pointer :: a(:,:,:)
      integer :: ashape(:)
    end subroutine test_reset
  end interface

  integer, dimension(3) :: ashape
  integer, dimension(3) :: shp = (/2,3,4/)

  integer :: i, j, k, ii, rank, elem_size
  integer :: albound(3), aubound(3)
  integer, target :: aa(1,1,1)
  integer, pointer :: a(:,:,:)
  logical :: debug = (.false.), error = (.false.)

  rank = 3
  elem_size = 4
  a => aa

  call test_reset(rank, a, elem_size, shp)

  ashape  = shape(a)
  albound = lbound(a)
  aubound = ubound(a)
  
   if (.not. associated(a)) then
      error = .true.
      print *, "ERROR, a is unassociated"
   end if

  if (debug) then
    print *, " size   of a =", size(a)
    print *, " lbound of a =", albound
    print *, " ubound of a =", aubound
    print *, " shape  of a =", shape(a)
    print *, '.'
    print '(4i6)', (((a(i,j,k),k=1,4),j=1,3),i=1,2)
    print *, '.'
  end if

  do i = 1, 3
    if (ashape(i) .ne. shp(i)) then
       error = .true.
       print *, "ERROR, shape(", i, ") = ", ashape(i)
    end if
    if (albound(i) .ne. 1) then
       error = .true.
       print *, "ERROR, lbound(", i, ") = ", albound(i)
    end if
    if (aubound(i) .ne. ashape(i)) then
       error = .true.
       print *, "ERROR, ubound(", i, ") = ", aubound(i)
    end if
  end do

  if (size(a) .ne. 2*3*4) then
    error = .true.
    print *, "ERROR, size(a) = ", size(a)
  end if

  ii = 1
  do i = 1, 2
    do j = 1, 3
      do k = 1, 4
        if (a(i,j,k) .ne. ii) then
           error = .true.
           print *, "ERROR a(", i, j, k, ") = ",  a(i,j,k)
        end if
        ii = ii + 1
      end do
    end do
  end do

  if (error) then
    print *, "FAILED to reset array correctly"
  end if

end program test_reset_F
