module blocks

  type visc_type
    real, dimension(:,:), pointer :: t
    integer :: imax,jmax
  end type visc_type

  type block_type
    real, dimension(:,:), pointer :: a
    type(visc_type), dimension(:), pointer :: visc
    real, dimension(3) :: b
    real :: c,d
    integer :: imax,jmax
  end type block_type

end module blocks

subroutine send_visc_type()
  use blocks
  interface
    subroutine recv_visc_type(t)
      use blocks      
      type(visc_type), intent(in) :: t
    end subroutine recv_visc_type
    subroutine recv_block_type(t)
      use blocks      
      type(block_type), intent(in) :: t
    end subroutine recv_block_type
  end interface

  type(visc_type), target :: vsc
  type(visc_type), target :: a_vsc(2)
  type(block_type) :: blk
  real, target :: a(3,4)

  vsc%t => a
  vsc%imax = 33
  vsc%jmax = 44
  call recv_visc_type(vsc)

  a_vsc(1) = vsc
  blk%a => a
  blk%visc => a_vsc
  blk%b = 1.1
  blk%c = 2.2
  blk%d = 3.3
  blk%imax = 33
  blk%jmax = 44
  call recv_block_type(blk)

end subroutine send_visc_type

program main
  call send_visc_type()
end program main
