!
! LANL:license
! -------------------------------------------------------------------------
! This SOFTWARE has been authored by an employee or employees of the
! University of California, operator of the Los Alamos National Laboratory
! under Contract No. W-7405-ENG-36 with the U.S. Department of Energy.
! The U.S. Government has rights to use, reproduce, and distribute this
! SOFTWARE.  The public may copy, distribute, prepare derivative works and
! publicly display this SOFTWARE without charge, provided that this Notice
! and any statement of authorship are reproduced on all copies.  Neither
! the Government nor the University makes any warranty, express or implied,
! or assumes any liability or responsibility for the use of this SOFTWARE.
! If SOFTWARE is modified to produce derivative works, such modified
! SOFTWARE should be clearly marked, so as not to confuse it with the
! version available from LANL.
! -------------------------------------------------------------------------
! LANL:license
! -------------------------------------------------------------------------
!

!
! this code is a test for generating XML from F90 Module INTERFACE blocks
! that are used for generic interfaces.
!
MODULE f90interfaces
  implicit none 
  
  INTERFACE simple
     SUBROUTINE simple1(a,b)
       INTEGER :: a,b
     END SUBROUTINE SIMPLE1

     SUBROUTINE simple2(x,y,z)
       INTEGER :: x,y
       REAL :: z
     end SUBROUTINE simple2

     module procedure simple3
  end INTERFACE
  
  contains

    subroutine simple3(a,b)
      real :: a,b

      print *,a
      print *,b
    end subroutine simple3

    subroutine notgeneric(a)
      integer :: a
    end subroutine notgeneric

  end MODULE f90interfaces

subroutine simple1(a,b)
  integer :: a,b

  print *,a
  print *,b
end subroutine simple1
